							.Code

; #########################################################################

NetWork_Socket				PROC		USES EBX EDI ESI

;	**************************
;	*** Cration du socket ***
;	**************************

							push		WSA_FLAG_OVERLAPPED
							push		0
							push		NULL
							push		IPPROTO_TCP
							push		SOCK_STREAM
							push		AF_INET
							push		OFFSET $ + 10
							jmp			WSASocket

							cmp			eax,INVALID_SOCKET
							je			NetWork_Socket_Error

;	*******************
;	*** Socket cr ***
;	*******************

							mov			UserProfile.NewsGroupSettings.hServer,eax
							jmp			NetWork_Socket_Exit

NetWork_Socket_Error :

;	*************************************
;	*** Cration du socket impossible ***
;	*************************************

							push		OFFSET $ + 10
							jmp			WSAGetLastError

							push		eax
							push		OFFSET Error_NetWork_0000
							push		OFFSET szTmp
							push		OFFSET $ + 10
							jmp			wsprintf
							add			esp,12

							push		OFFSET szTmp
							push		OFFSET NetWork_Socket_Exit

							cmp			UserProfile.User.bVerbose,TRUE
							jne			Log

							push		OFFSET szTmp
							push		NULL
							push		OFFSET Log
							jmp			Error_Display

NetWork_Socket_Exit :

							ret
NetWork_Socket				ENDP

; #########################################################################

NewGroupList_Transform		PROC		USES EBX EDI ESI,hWin:HWND
							LOCAL		lpszGroup:LPSTR
							LOCAL		dwLast:DWord
							LOCAL		Ngh:NEWSGROUPHEADER
							LOCAL		Ngl:NEWSGROUPLIST

							mov			Ngh.dwVersion,PROGRAMME_VERSION
							mov			Ngh.dwNbGroups,0
							mov			Ngh.dwSize,SIZEOF NEWSGROUPHEADER
							mov			Ngh.dwReserved,-1

							push		SIZEOF NEWSGROUPHEADER
							lea			eax,Ngh
							push		eax
							push		hNg
							push		OFFSET $ + 10
							jmp			Files_Write

							push		OFFSET szLog_0025
							push		OFFSET $ + 10
							jmp			Log

NewGroupList_Transform_1 :

							push		hWin
							push		OFFSET $ + 10
							jmp			Transform_Dialog

							xor			eax,eax

							mov			dwLast,eax
							mov			Ngl.dwNbGroups,0

							mov			ecx,UserProfile.NewsGroupSettings.dwNewsGroupListLength
							mov			eax,UserProfile.NewsGroupSettings.lpszNewsGroup

							mov			edi,eax

							test		eax,eax
							jz			NewGroupList_Transform_Exit

;	****************************************
;	*** Sauter le premier enregistrement ***
;	****************************************

							mov			al,0ah
							repne		scasb

NewGroupList_Transform_Loop :

							cmp			Byte PTR [edi],'.'					; Fin des donnes ?
							je			NewGroupList_Transform_Exit

							mov			eax,dwLast
							inc			eax
							mov			dwLast,eax
							mov			Ngh.dwNbGroups,eax

;	****************************
;	*** Mettre le buffer  0 ***
;	****************************

							push		ecx
							push		edi

							lea			edi,Ngl
							xor			eax,eax
							mov			ecx,(SIZEOF NEWSGROUPLIST) / 4

							rep			stosd

							pop			edi
							pop			ecx

							mov			lpszGroup,edi

							mov			esi,edi

;	***********************************
;	*** Rechercher le premier blanc ***
;	***********************************

							mov			al,' '
							repne		scasb
							mov			eax,edi
							sub			eax,esi
							mov			Byte Ptr [edi - 1],0		; Sparer le nom du groupe

							inc			eax
							mov			Ngl.dwTextLength,eax

							push		ecx

							push		lpszGroup
							lea			eax,Ngl.szGroup
							push		eax
							push		OFFSET $ + 10
							jmp			lstrcpy						; Recopier le nom du groupe

							pop			ecx

;	***********************************************************************************
;	*** Rechercher le premier blanc du plus petit nombre de messages dans ce groupe ***
;	***********************************************************************************

							push		edi							; Pour a2dw

							mov			al,' '
							repne		scasb
							mov			Byte Ptr [edi - 1],0

							push		OFFSET $ + 10
							jmp			a2dw

							mov			Ngl.dwHigh,eax

;	***********************************************************************************
;	*** Rechercher le premier blanc du plus grand nombre de messages dans ce groupe ***
;	***********************************************************************************

							push		edi							; pour a2dw

							mov			al,' '
							repne		scasb
							mov			Byte Ptr [edi - 1],0

							push		OFFSET $ + 10
							jmp			a2dw

							mov			Ngl.dwLow,eax

;	****************************************************
;	*** Rechercher si ce groupe autorise l'uploading ***
;	****************************************************

							cmp			Byte Ptr [edi],'y'
							jne			NewGroupList_Transform_Next

							mov			Ngl.dwFlags,TRUE

NewGroupList_Transform_Next :

							push		ecx
							push		edi

							mov			eax,dwLast
							mov			Ngl.dwNbGroups,eax

;	****************************************************************************
;	*** Mettre dans la log le groupe de discussion que l'on vient de traiter ***
;	****************************************************************************

							push		lpszGroup
							push		Ngl.dwNbGroups
							push		OFFSET szLog_0028
							push		OFFSET szTmp
							push		OFFSET $ + 10
							jmp			wsprintf

							add			esp,16

							push		OFFSET szTmp
							push		OFFSET $ + 10
							jmp			Log

;	*******************************************************************************************
;	*** Envoyer un message permettant de connatre l'tat d'avancement de la transformation ***
;	*******************************************************************************************

							lea			eax,Ngl
							push		eax
							push		IDM_NEWSGROUP_01
							push		WM_COMMAND
							push		hWndNewsGroupList
							push		OFFSET $ + 10
							jmp			SendMessage

;	***************************************
;	*** Ecrire les donnes transformes ***
;	***************************************

							push		SIZEOF NEWSGROUPLIST
							lea			eax,Ngl
							push		eax
							push		hNg
							push		OFFSET $ + 10
							jmp			Files_Write

NewGroupList_Transform_Next_2 :

							pop			edi
							pop			ecx

;	**************************************************
;	*** Vrifier que les donnes sont bien crites ***
;	**************************************************

							test		eax,eax
							jz			NewGroupList_Transform_Error

							inc			edi
							inc			edi
							inc			edi

							sub			ecx,3
							jnz			NewGroupList_Transform_Loop

							jmp			NewGroupList_Transform_Exit

NewGroupList_Transform_Error :

;	******************************************************************************************
;	*** Une erreur s'est produite lors de l'criture de la liste des groupes de discussion ***
;	******************************************************************************************

							xor			eax,eax
							mov			UserProfile.NewsGroupSettings.bNewsGroupListOk,eax

							push		OFFSET szLog_0044
							push		OFFSET NewGroupList_Transform_End

							push		OFFSET szError_014
							push		NULL
							push		OFFSET Log
							jmp			Error_Display

NewGroupList_Transform_Exit :

;	**************************************************************************
;	*** Sauver le nombre de groupes de discussion dans l'entte du fichier ***
;	**************************************************************************

							push		FILE_BEGIN
							push		0
							push		0
							push		hNg
							push		OFFSET $ + 10
							jmp			SetFilePointer

							dec			Ngh.dwNbGroups

							push		SIZEOF NEWSGROUPHEADER
							lea			eax,Ngh
							push		eax
							push		hNg
							push		OFFSET $ + 10
							jmp			Files_Write

							test		eax,eax
							jz			NewGroupList_Transform_Error

							mov			UserProfile.NewsGroupSettings.bNewsGroupListOk,TRUE

NewGroupList_Transform_End :

							ret
NewGroupList_Transform		ENDP

; #########################################################################

NetWork_Verif_GroupList		PROC		USES EBX EDI ESI,hWin:HWND
							LOCAL		szTmpBuf[512]:Byte

							mov			UserProfile.NewsGroupSettings.bNewsGroupListOk,FALSE

							push		OFFSET UserProfile.User.szNewsServer
							push		OFFSET szFmtNewsGroupList
							push		OFFSET UserProfile.User.szNewsGroupFile
							push		OFFSET $ + 10
							jmp			wsprintf
							add			esp,12

							push		OFFSET szLog_0020
							push		OFFSET $ + 10
							jmp			Log

							push		OFFSET UserProfile.User.szNewsGroupFile
							push		OFFSET $ + 10
							jmp			PathFileExists

							test		eax,eax
							jz			NetWork_Verif_GroupList_No

							lea			eax,szTmpBuf
							push		eax
							push		OFFSET $ + 10
							jmp			Log

							push		OFFSET UserProfile.User.szNewsGroupFile
							push		OFFSET szLog_0022
							lea			eax,szTmpBuf
							push		eax
							push		OFFSET $ + 10
							jmp			wsprintf

							add			esp,12

							push		OFFSET UserProfile.User.szNewsGroupFile
							push		OFFSET $ + 10
							jmp			Files_OpenExisting

							test		eax,eax
							jz			NetWork_Verif_GroupList_No

							mov			hNg,eax

							push		NULL
							push		eax
							push		OFFSET $ + 10
							jmp			GetFileSize

							cmp			eax,INVALID_FILE_SIZE
							je			NetWork_Verif_GroupList_4

							test		eax,eax
							jz			NetWork_Verif_GroupList_4

							push		hNg
							push		OFFSET NetWork_Verif_GroupList_3
							jmp			Files_Close

							push		hWndNewsGroupList
							push		OFFSET $ + 10
							jmp			DestroyWindow

NetWork_Verif_GroupList_3 :

							xor			eax,eax
							inc			eax

							mov			UserProfile.NewsGroupSettings.bNewsGroupListOk,eax
							jmp			NetWork_Verif_GroupList_Exit

NetWork_Verif_GroupList_4 :

							push		hNg
							push		OFFSET $ + 10
							jmp			Files_Close

							push		OFFSET UserProfile.User.szNewsGroupFile
							push		OFFSET $ + 10
							jmp			DeleteFile

;	*******************************************************
;	*** La liste des groupes de discussion n'existe pas ***
;	*******************************************************

NetWork_Verif_GroupList_No :

							push		OFFSET UserProfile.User.szNewsGroupFile
							push		OFFSET szLog_0021
							lea			eax,szTmpBuf
							push		eax
							push		OFFSET $ + 10
							jmp			wsprintf

							add			esp,12

							lea			eax,szTmpBuf
							push		eax
							push		OFFSET $ + 10
							jmp			Log

							push		OFFSET UserProfile.User.szNewsGroupFile
							push		OFFSET szQuest_0001
							lea			eax,szTmpBuf
							push		eax
							push		OFFSET $ + 10
							jmp			wsprintf

							add			esp,12

							lea			eax,szTmpBuf
							push		eax
							push		hWin
							push		OFFSET $ + 10
							jmp			Oui

							test		eax,eax
							jz			NetWork_Verif_GroupList_Exit

							push		0
							push		SIZEOF szNewsGroup_Order_List
							push		OFFSET szNewsGroup_Order_List
							push		UserProfile.NewsGroupSettings.hServer
							push		OFFSET $ + 10
							jmp			send

							cmp			eax,SOCKET_ERROR
							je			NetWork_Verif_GroupList_Error

;	**************************************************
;	*** Charger la liste des groupes de discussion ***
;	**************************************************

							push		hWin
							push		OFFSET @F
							jmp			NetWork_Receive

@@ :

							cmp			UserProfile.NewsGroupSettings.bReceivedError,TRUE
							je			NetWork_Verif_GroupList_Error

							mov			UserProfile.NewsGroupSettings.lpszNewsGroup,eax
							mov			UserProfile.NewsGroupSettings.dwNewsGroupListLength,edx

							push		OFFSET UserProfile.User.szNewsGroupFile
							push		OFFSET $ + 10
							jmp			Files_Create

							mov			hNg,eax

							push		hWin
							push		OFFSET @F
							jmp			NewGroupList_Transform

@@ :

							push		hNg
							push		OFFSET $ + 10
							jmp			Files_Close

							push		hWndNewsGroupList
							push		OFFSET $ + 10
							jmp			DestroyWindow

							xor			eax,eax
							inc			eax

							jmp			NetWork_Verif_GroupList_Exit

NetWork_Verif_GroupList_Error :

							xor			eax,eax
							mov			edx,eax

							mov			UserProfile.NewsGroupSettings.lpszNewsGroup,eax
							mov			UserProfile.NewsGroupSettings.bNewsGroupListOk,eax
							mov			UserProfile.NewsGroupSettings.dwNewsGroupListLength,eax

NetWork_Verif_GroupList_Exit :

							ret
NetWork_Verif_GroupList		ENDP

; #########################################################################

NetWork_GetHostByName		PROC		USES EBX EDI ESI

							push		UserProfile.User.dwPort
							push		OFFSET $ + 10
							jmp			htons

							mov			UserProfile.NewsGroupSettings.SockAddr.sin_port,ax

							push		OFFSET UserProfile.User.szNewsServer
							push		OFFSET $ + 10
							jmp			gethostbyname

							test		eax,eax
							jnz			NetWork_GetHostByName_Ok

;	**********************************************************
;	*** Rcupration de l'adresse IP du serveur impossible ***
;	**********************************************************

							push		OFFSET $ + 10
							jmp			WSAGetLastError

							cmp			eax,WSAHOST_NOT_FOUND
							je			NetWork_GetHostByName_NotFound

							push		eax
							push		OFFSET Error_NetWork_0000
							push		OFFSET szTmp
							push		OFFSET $ + 10
							jmp			wsprintf
							add			esp,12

							push		OFFSET szTmp
							push		OFFSET NetWork_GetHostByName_Exit

							cmp			UserProfile.User.bVerbose,TRUE
							jne			Log

							push		OFFSET szTmp
							push		NULL
							push		OFFSET Log
							jmp			Error_Display

NetWork_GetHostByName_NotFound :

							push		OFFSET szLog_0006
							push		OFFSET NetWork_GetHostByName_Exit

							cmp			UserProfile.User.bVerbose,TRUE
							jne			Log

							push		OFFSET szError_013
							push		NULL
							push		OFFSET Log
							jmp			Error_Display

NetWork_GetHostByName_Ok :

;	***************************************************************
;	*** Enregistrer toutes les adresses fournies par le serveur ***
;	***************************************************************

							push		edi
							mov			esi,eax
							mov			edi,OFFSET UserProfile.NewsGroupSettings.HostEnt
							mov			ecx,((SIZEOF hostent) / (SIZEOF DWord))
							rep			movsd
							pop			edi

							mov			ecx,MAX_ADRESSES_IP
							mov			esi,UserProfile.NewsGroupSettings.HostEnt.h_list
							mov			edi,OFFSET UserProfile.NewsGroupSettings.AdressesIP

NetWork_GetHostByName_Ok_1 :

							lodsd

							test		eax,eax
							jz			NetWork_GetHostByName_Ok_2

							mov			eax,DWord Ptr [eax]
							stosd

							dec			ecx
							jnz			NetWork_GetHostByName_Ok_1

NetWork_GetHostByName_Ok_2 :

							xor			eax,eax
							inc			eax

NetWork_GetHostByName_Exit :

							ret
NetWork_GetHostByName		ENDP

; #########################################################################

NetWork_Connect				PROC		USES EBX EDI ESI

;	*********************************************************************
;	*** Positionner les diffrents rglages : TIMEOUT, RECEIVE & SEND ***
;	*********************************************************************

							push		SIZEOF DWord
							push		OFFSET UserProfile.User.dwReceiveTimeOut
							push		SO_RCVTIMEO
							push		SOL_SOCKET
							push		UserProfile.NewsGroupSettings.hServer
							push		OFFSET $ + 10
							jmp			setsockopt

							push		SIZEOF DWord
							push		OFFSET UserProfile.User.dwSendTimeOut
							push		SO_SNDTIMEO
							push		SOL_SOCKET
							push		UserProfile.NewsGroupSettings.hServer
							push		OFFSET $ + 10
							jmp			setsockopt

							push		SIZEOF DWord
							push		UserProfile.User.dwReceiveBufferSize
							push		SO_RCVBUF
							push		SOL_SOCKET
							push		UserProfile.NewsGroupSettings.hServer
							push		OFFSET $ + 10
							jmp			setsockopt

							push		SIZEOF DWord
							push		OFFSET UserProfile.User.dwSendBufferSize
							push		SO_SNDBUF
							push		SOL_SOCKET
							push		UserProfile.NewsGroupSettings.hServer
							push		OFFSET $ + 10
							jmp			setsockopt

NetWork_Connect_0 :

							mov			UserProfile.NewsGroupSettings.bConnected,0

							mov			UserProfile.NewsGroupSettings.SockAddr.sin_family,AF_INET
							mov			eax,UserProfile.NewsGroupSettings.AdressesIP.S_un
							mov			UserProfile.NewsGroupSettings.SockAddr.sin_addr,eax

;	*******************************
;	*** Effectuer la connection ***
;	*******************************

							push		NULL
							push		NULL
							push		NULL			; CalleeData
							push		NULL			; CallerData
							push		SIZEOF sockaddr_in
							push		OFFSET UserProfile.NewsGroupSettings.SockAddr
							push		UserProfile.NewsGroupSettings.hServer
							push		OFFSET $ + 10
							jmp			WSAConnect

							test		eax,eax
							jz			NetWork_Connect_Ok

;	*****************************
;	*** Connection impossible ***
;	*****************************

							push		OFFSET $ + 10
							jmp			WSAGetLastError

							push		eax
							push		OFFSET Error_NetWork_0000
							push		OFFSET szTmp
							push		OFFSET $ + 10
							jmp			wsprintf
							add			esp,12

NetWork_Connect_1 :

;	******************************************
;	*** La connection au serveur a choue ***
;	******************************************

							add			esp,12

							push		OFFSET szTmp
							push		OFFSET $ + 10
							jmp			Log

							push		OFFSET szTmp
							push		NULL
							push		OFFSET $ + 10
							jmp			Error_Display

NetWork_Connect_Ok :

							push		OFFSET UserProfile.User.szNewsServer
							push		OFFSET szLog_0001
							push		OFFSET szTmp
							push		OFFSET $ + 10
							jmp			wsprintf

							add			esp,12

							push		OFFSET szTmp
							push		OFFSET $ + 10
							jmp			Log

;	******************************************
;	*** La connection au serveur a russie ***
;	******************************************

							xor			eax,eax
							inc			eax

							mov			UserProfile.NewsGroupSettings.bConnected,eax

NetWork_Connect_Exit :

							ret
NetWork_Connect				ENDP

; #########################################################################

ConnectToServer				PROC		USES EBX EDI ESI,hWin:HWND
							LOCAL		szTemp[256]:Byte

							push		OFFSET szLog_0008
							push		OFFSET $ + 10
							jmp			Log

;	***************************************************
;	*** Afficher la bote de dialogue de connection ***
;	***************************************************

							push		hWin
							push		OFFSET $ + 10
							jmp			Connect_Dialog

;	**********************************************************
;	*** Rechercher si l'utilisateur est connect au rseau ***
;	**********************************************************

							push		NULL
							push		IDM_CONNECT_001
							push		WM_COMMAND
							push		hWndConnect
							push		OFFSET $ + 10
							jmp			SendMessage

							push		OFFSET ConnectToServer_2
							jmp			NetWork_GetHostByName

ConnectToServer_2 :

							test		eax,eax
							jz			ConnectToServer_Exit_2

							push		OFFSET szLog_0009
							push		OFFSET $ + 10
							jmp			Log

;	***************************************
;	*** Crer un socket pour le serveur ***
;	***************************************

							push		NULL
							push		IDM_CONNECT_003
							push		WM_COMMAND
							push		hWndConnect
							push		OFFSET $ + 10
							jmp			SendMessage

							push		OFFSET ConnectToServer_3
							jmp			NetWork_Socket

ConnectToServer_3 :

							test		eax,eax
							jz			ConnectToServer_Exit

							push		OFFSET szLog_0011
							push		OFFSET ConnectToServer_4

;	******************************************
;	*** Effectuer la connection au serveur ***
;	******************************************

							push		OFFSET Log
							jmp			NetWork_Connect

ConnectToServer_4 :

							test		eax,eax
							jz			ConnectToServer_Exit_3

;	**************************************************************
;	*** Connection ralise, rcuprer le message de bienvenue ***
;	**************************************************************

							push		NULL
							push		IDM_CONNECT_004
							push		WM_COMMAND
							push		hWndConnect
							push		OFFSET $ + 10
							jmp			SendMessage

							push		OFFSET szLog_0014
							push		OFFSET $ + 10
							jmp			Log

							push		OFFSET szLog_0012
							push		OFFSET $ + 10
							jmp			Log

							push		NULL
							push		OFFSET $ + 10
							jmp			NetWork_Receive

ConnectToServer_5 :

							test		eax,eax
							jz			ConnectToServer_Exit_4

;	**************************************************
;	*** Message de bienvenue correctement rcupr ***
;	**************************************************

							mov			UserProfile.NewsGroupSettings.lpszWelcome,eax
							dec			edx
							dec			edx
							mov			UserProfile.NewsGroupSettings.dwWelcomeMsgLength,edx
							mov			DWord Ptr [eax + edx],0

							push		UserProfile.NewsGroupSettings.lpszWelcome
							push		OFFSET ConnectToServer_5_1

							push		OFFSET szLog_0015
							push		OFFSET Log
							jmp			Log

ConnectToServer_5_1 :

;	**************************************************
;	*** Mettre le message de bienvenue dans la log ***
;	**************************************************

							push		UserProfile.NewsGroupSettings.lpszWelcome
							push		OFFSET $ + 10
							jmp			Log

;	****************************************
;	*** Analyser le message de bienvenue ***
;	****************************************

							mov			eax,UserProfile.NewsGroupSettings.lpszWelcome
							mov			eax,DWord Ptr [eax]

							cmp			eax," 002"
							je			ConnectToServer_AllowsPosting

							cmp			eax," 102"
							je			ConnectToServer_DoesNotAllowPosting

;	*********************************************************************
;	*** Le message de bienvenue ne correspond pas aux code 200 ou 201 ***
;	*********************************************************************

							push		OFFSET UserProfile.User.szNewsServer
							push		OFFSET szLog_0043
							lea			eax,szTemp
							push		eax
							push		OFFSET $ + 10
							jmp			wsprintf
							add			esp,12

							lea			eax,szTemp
							push		eax
							push		OFFSET $ + 10
							jmp			Log

							push		MB_ICONEXCLAMATION
							push		OFFSET $ + 10
							jmp			MessageBeep

							push		MB_OK or MB_ICONERROR or MB_APPLMODAL
							push		OFFSET szDisplayName
							lea			eax,szTemp
							push		eax
							push		hWin
							push		OFFSET $ + 10
							jmp			MessageBox

;	*****************************
;	*** L'opration a echoue ***
;	*****************************

							xor			eax,eax
							jmp			ConnectToServer_Exit

ConnectToServer_DoesNotAllowPosting :

							push		OFFSET szLog_0019
							jmp			ConnectToServer_Ok

ConnectToServer_AllowsPosting :

							push		OFFSET szLog_0018

ConnectToServer_Ok :

							push		hWndConnect
							push		OFFSET $ + 10
							jmp			DestroyWindow

							mov			hWndConnect,NULL

							push		OFFSET $ + 10
							jmp			Log

							push		hWin
							push		OFFSET ConnectToServer_Ok_1
							jmp			NetWork_Verif_GroupList

ConnectToServer_Ok_1 :

;	***************************************************************************
;	*** Ici, il faut vrifier si le server ncessite un login de connection ***
;	***************************************************************************

							cmp			DWord Ptr UserProfile.User.bRequireLogin,TRUE
							jne			ConnectToServer_Ok_NoLogin

;	****************************************
;	*** Prparer la chane de connection ***
;	****************************************

							push		OFFSET UserProfile.User.szNewsPassWord
							push		OFFSET UserProfile.User.szNewsLogin
							push		OFFSET szNewsGroup_Order_Login
							push		OFFSET szTmp
							push		OFFSET ConnectToServer_Ok_2

							push		OFFSET szLog_0047
							push		OFFSET wsprintf
							jmp			Log

ConnectToServer_Ok_2 :

							add			esp,16 

;	***************************************
;	*** Envoyer la chane de connection ***
;	***************************************

							push		0
							push		eax
							push		OFFSET szTmp

							push		OFFSET szTmp
							push		OFFSET $ + 10
							jmp			Log

							push		UserProfile.NewsGroupSettings.hServer
							push		OFFSET $ + 10
							jmp			send

							cmp			eax,SOCKET_ERROR
							jne			ConnectToServer_Ok_4

;	*******************************************************************
;	*** Une erreur est survenue lors de l'envoi de la commande send ***
;	*******************************************************************

							push		OFFSET $ + 10
							jmp			WSAGetLastError

							push		OFFSET szTmp
							push		hWin
							push		OFFSET ConnectToServer_Ok_5

							push		OFFSET szTmp
							push		OFFSET Error_Display

							push		eax
							push		OFFSET Error_NetWork_0000
							push		OFFSET szTmp
							push		OFFSET Log
							jmp			wsprintf

ConnectToServer_Ok_5 :

							add			esp,12
							jmp			ConnectToServer_Exit

ConnectToServer_Ok_4 :

;	***************************************
;	*** Rcuprer la rponse du serveur ***
;	***************************************

							push		hWin
							push		OFFSET ConnectToServer_Ok_6
							jmp			NetWork_Receive

ConnectToServer_Ok_6 :

							test		eax,eax
							jz			ConnectToServer_Exit

							mov			UserProfile.NewsGroupSettings.dwLoginLength,edx
							mov			UserProfile.NewsGroupSettings.lpszLogin,eax

							cmp			DWord Ptr [eax],"281 "
							je			ConnectToServer_Ok_NoLogin

;	********************************************
;	*** Le login a t refus par le serveur ***
;	********************************************

							push		OFFSET szLog_0048
							push		OFFSET ConnectToServer_Exit

							push		offset szError_018
							push		hWin
							push		OFFSET Log
							jmp			Error_Display

ConnectToServer_Ok_NoLogin :

;	*************************************************************
;	*** Afficher un message indicant que la connection est OK ***
;	*************************************************************

							cmp			UserProfile.User.bVerbose,TRUE
							jne			ConnectToServer_Ok_3

							push		MB_OK
							push		OFFSET $ + 10
							jmp			MessageBeep

							push		OFFSET szLog_0005
							push		OFFSET $ + 10
							jmp			Log

							push		MB_OK or MB_ICONINFORMATION
							push		OFFSET szConnectionTitle
							push		OFFSET szSuccessfulConnectionMessage
							push		hWin
							push		OFFSET $ + 10
							jmp			MessageBox

ConnectToServer_Ok_3 :

;	*******************************************************************************************
;	*** Envoyer un message  la fentre pour connatre l'tat d'avancement de la connection ***
;	*******************************************************************************************

							push		NULL
							push		IDM_CONNECT_005
							push		WM_COMMAND
							push		hWndConnect
							push		OFFSET $ + 10
							jmp			SendMessage

;	*****************************
;	*** L'opration a russie ***
;	*****************************

							cmp			UserProfile.NewsGroupSettings.bNewsGroupListOk,TRUE
							jne			ConnectToServer_Ok_3_1

;	*******************************
;	*** Initialiser le treeview ***
;	*******************************

							push		NULL
							push		INIT_TREEVIEW
							push		WM_COMMAND
							push		hWndExplorer
							push		OFFSET ConnectToServer_Ok_3_1
							jmp			SendMessage

ConnectToServer_Ok_3_1 :

							xor			eax,eax
							inc			eax
							jmp			ConnectToServer_Exit

ConnectToServer_Exit_4 :

							push		OFFSET szLog_0016
							jmp			ConnectToServer_Exit_0

ConnectToServer_Exit_3 :

							push		OFFSET szLog_0013
							jmp			ConnectToServer_Exit_0

ConnectToServer_Exit_2 :

							push		NULL
							push		IDM_CONNECT_002
							push		WM_COMMAND
							push		hWndConnect
							push		OFFSET $ + 10
							jmp			SendMessage

							push		OFFSET szLog_0042
							push		OFFSET $ + 10
							jmp			Log

							push		OFFSET szLog_0010
							jmp			ConnectToServer_Exit_0

ConnectToServer_Exit_1 :

							push		OFFSET szLog_0005

ConnectToServer_Exit_0 :

							push		OFFSET ConnectToServer_Exit
							jmp			Log

ConnectToServer_Exit :

							cmp			hWndConnect,NULL
							je			ConnectToServer_Exit_Exit

							push		eax

							push		hWndConnect
							push		OFFSET $ + 10
							jmp			DestroyWindow

							pop			eax

ConnectToServer_Exit_Exit :

							ret
ConnectToServer				ENDP

; #########################################################################
